Note
Access to this page requires authorization. You can try signing in or changing directories.
Access to this page requires authorization. You can try changing directories.
API Version: v1
Server: {endpoint}/openai/v1 — Azure AI Foundry Models APIs
Server Variables:
| Variable | Default | Description |
|---|---|---|
| endpoint | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
Authentication
ApiKeyAuth (API Key)
Pass your API key in the api-key header.
ApiKeyAuth_ (API Key)
Pass your API key in the authorization header.
OAuth2Auth (OAuth 2.0)
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/v2.0/authorize
Scopes:
https://cognitiveservices.azure.com/.default
Security Requirements
Endpoints accept any one of the following authentication methods:
- ApiKeyAuth
- ApiKeyAuth_
- OAuth2Auth (scopes:
https://cognitiveservices.azure.com/.default)
List evals
GET {endpoint}/openai/v1/evals
List evaluations for a project.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| after | query | No | string | Identifier for the last eval from the previous pagination request. Serialization: explode: false |
| limit | query | No | integer (int32) | A limit on the number of evals to be returned in a single pagination response. Serialization: explode: false |
| order | query | No | string Possible values: asc, desc |
Sort order for evals by timestamp. Use asc for ascending order ordesc for descending order.Serialization: explode: false |
| order_by | query | No | string Possible values: created_at, updated_at |
Evals can be ordered by creation time or last updated time. Usecreated_at for creation time or updated_at for last updatedtime. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalList |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Create eval
POST {endpoint}/openai/v1/evals
Create the structure of an evaluation that can be used to test a model's performance.
An evaluation is a set of testing criteria and a datasource. After creating an evaluation, you can run it on different models and model parameters. We support several types of graders and datasources.
For more information, see the Evals guide.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data_source_config | OpenAI.CreateEvalCustomDataSourceConfig or OpenAI.CreateEvalLogsDataSourceConfig or OpenAI.CreateEvalStoredCompletionsDataSourceConfig | The configuration for the data source used for the evaluation runs. Dictates the schema of the data used in the evaluation. | Yes | |
| metadata | OpenAI.Metadata or null | No | ||
| name | string | The name of the evaluation. | No | |
| statusCode | enum | Possible values: 201 |
Yes | |
| testing_criteria | array of OpenAI.CreateEvalLabelModelGrader or OpenAI.EvalGraderStringCheck or OpenAI.EvalGraderTextSimilarity or OpenAI.EvalGraderPython or OpenAI.EvalGraderScoreModel or EvalGraderEndpoint | A list of graders for all eval runs in this group. Graders can reference variables in the data source using double curly braces notation, like {{item.variable_name}}. To reference the model's output, use the sample namespace (ie, {{sample.output_text}}). |
Yes |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.Eval |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Get eval
GET {endpoint}/openai/v1/evals/{eval_id}
Retrieve an evaluation by its ID. Retrieves an evaluation by its ID.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.Eval |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Update eval
POST {endpoint}/openai/v1/evals/{eval_id}
Update select, mutable properties of a specified evaluation.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| metadata | OpenAI.Metadata | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| name | string | No |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.Eval |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Delete eval
DELETE {endpoint}/openai/v1/evals/{eval_id}
Delete a specified evaluation.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| deleted | boolean | Yes | ||
| eval_id | string | Yes | ||
| object | enum | Possible values: eval.deleted |
Yes |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Get eval runs
GET {endpoint}/openai/v1/evals/{eval_id}/runs
Retrieve a list of runs for a specified evaluation.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string | |
| after | query | No | string | Serialization: explode: false |
| limit | query | No | integer (int32) | Serialization: explode: false |
| order | query | No | string Possible values: asc, desc |
Serialization: explode: false |
| status | query | No | string Possible values: queued, in_progress, completed, canceled, failed |
Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalRunList |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Create eval run
POST {endpoint}/openai/v1/evals/{eval_id}/runs
Create a new evaluation run, beginning the grading process.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data_source | OpenAI.CreateEvalJsonlRunDataSource or OpenAI.CreateEvalCompletionsRunDataSource or OpenAI.CreateEvalResponsesRunDataSource | Details about the run's data source. | Yes | |
| metadata | OpenAI.Metadata or null | No | ||
| name | string | The name of the run. | No |
Responses
Status Code: 201
Description: The request has succeeded and a new resource has been created as a result.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalRun |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Get eval run
GET {endpoint}/openai/v1/evals/{eval_id}/runs/{run_id}
Retrieve a specific evaluation run by its ID.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string | |
| run_id | path | Yes | string |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalRun |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Cancel eval run
POST {endpoint}/openai/v1/evals/{eval_id}/runs/{run_id}
Cancel a specific evaluation run by its ID.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string | |
| run_id | path | Yes | string |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalRun |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Delete eval run
DELETE {endpoint}/openai/v1/evals/{eval_id}/runs/{run_id}
Delete a specific evaluation run by its ID.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string | |
| run_id | path | Yes | string |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| deleted | boolean | Yes | ||
| eval_run_id | string | Yes | ||
| object | enum | Possible values: eval_run.deleted |
Yes |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Get eval run output items
GET {endpoint}/openai/v1/evals/{eval_id}/runs/{run_id}/output_items
Get a list of output items for a specified evaluation run.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string | |
| run_id | path | Yes | string | |
| after | query | No | string | Serialization: explode: false |
| limit | query | No | integer (int32) | Serialization: explode: false |
| status | query | No | string Possible values: fail, pass |
Serialization: explode: false |
| order | query | No | string Possible values: asc, desc |
Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalRunOutputItemList |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Get eval run output item
GET {endpoint}/openai/v1/evals/{eval_id}/runs/{run_id}/output_items/{output_item_id}
Retrieve a specific output item from an evaluation run by its ID.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname. For example: https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/). |
| api-version | query | No | string Possible values: v1, preview |
The explicit Azure AI Foundry Models API version to use for this request.v1 if not otherwise specified. |
| eval_id | path | Yes | string | |
| run_id | path | Yes | string | |
| output_item_id | path | Yes | string |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | OpenAI.EvalRunOutputItem |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| inner_error | No | |||
| message | string | Yes | ||
| param | string or null | No | ||
| type | string | No |
Response Headers:
| Header | Type | Description |
|---|---|---|
| apim-request-id | string | A request ID used for troubleshooting purposes. |
Components
AzureAIFoundryModelsApiVersion
| Property | Value |
|---|---|
| Type | string |
| Values | v1preview |
AzureCompletionsSamplingParams
Sampling parameters for controlling the behavior of completions.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| max_completion_tokens | integer | No | ||
| max_tokens | integer (int32) | The maximum number of tokens in the generated output. | No | |
| reasoning_effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| response_format | OpenAI.ResponseFormatText or OpenAI.ResponseFormatJsonSchema or OpenAI.ResponseFormatJsonObject | No | ||
| seed | integer | A seed value initializes the randomness during sampling. | No | 42 |
| temperature | number | A higher temperature increases randomness in the outputs. | No | 1 |
| tools | array of OpenAI.ChatCompletionTool | No | ||
| top_p | number | An alternative to temperature for nucleus sampling; 1.0 includes all tokens. | No | 1 |
AzureResponsesSamplingParams
Sampling parameters for controlling the behavior of responses.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| max_tokens | integer (int32) | The maximum number of tokens in the generated output. | No | |
| reasoning_effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| seed | integer | A seed value initializes the randomness during sampling. | No | 42 |
| temperature | number | A higher temperature increases randomness in the outputs. | No | 1 |
| text | OpenAI.CreateEvalResponsesRunDataSourceSamplingParamsText | No | ||
| tools | array of OpenAI.Tool | No | ||
| top_p | number | An alternative to temperature for nucleus sampling; 1.0 includes all tokens. | No | 1 |
AzureToolApprovalResponse
Azure tool approval response
An Azure tool approval response in the request input.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| approval_request_id | string | The ID of the approval request being answered. | Yes | |
| approve | boolean | Whether the request was approved. | Yes | |
| type | enum | The type of the item. Always tool_approval_response.Possible values: tool_approval_response |
Yes |
EvalGraderEndpoint
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| headers | object or null | Optional HTTP headers to include in requests to the endpoint | No | |
| name | string | The name of the grader | Yes | |
| pass_threshold | number or null | Optional threshold score above which the grade is considered passing If not specified, all scores are considered valid |
No | |
| rate_limit | integer or null | Optional rate limit for requests per second to the endpoint Must be a positive integer |
No | |
| type | enum | Possible values: endpoint |
Yes | endpoint |
| url | string | The HTTPS URL of the endpoint to call for grading Constraints: pattern: ^https:// |
Yes |
OpenAI.Annotation
An annotation that applies to a span of output text.
Discriminator for OpenAI.Annotation
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
file_citation |
OpenAI.FileCitationBody |
url_citation |
OpenAI.UrlCitationBody |
container_file_citation |
OpenAI.ContainerFileCitationBody |
file_path |
OpenAI.FilePath |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.AnnotationType | Yes |
OpenAI.AnnotationType
| Property | Value |
|---|---|
| Type | string |
| Values | file_citationurl_citationcontainer_file_citationfile_path |
OpenAI.ApplyPatchCallOutputStatusParam
Apply patch call output status
Outcome values reported for apply_patch tool call outputs.
| Property | Value |
|---|---|
| Type | string |
| Values | completedfailed |
OpenAI.ApplyPatchCallStatusParam
Apply patch call status
Status values reported for apply_patch tool calls.
| Property | Value |
|---|---|
| Type | string |
| Values | in_progresscompleted |
OpenAI.ApplyPatchCreateFileOperationParam
Apply patch create file operation
Instruction for creating a new file via the apply_patch tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| diff | string | Unified diff content to apply when creating the file. Constraints: maxLength: 10485760 |
Yes | |
| path | string | Path of the file to create relative to the workspace root. Constraints: minLength: 1 |
Yes | |
| type | enum | The operation type. Always create_file.Possible values: create_file |
Yes | create_file |
OpenAI.ApplyPatchDeleteFileOperationParam
Apply patch delete file operation
Instruction for deleting an existing file via the apply_patch tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| path | string | Path of the file to delete relative to the workspace root. Constraints: minLength: 1 |
Yes | |
| type | enum | The operation type. Always delete_file.Possible values: delete_file |
Yes | delete_file |
OpenAI.ApplyPatchOperationParam
Apply patch operation
One of the create_file, delete_file, or update_file operations supplied to the apply_patch tool.
Discriminator for OpenAI.ApplyPatchOperationParam
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
create_file |
OpenAI.ApplyPatchCreateFileOperationParam |
delete_file |
OpenAI.ApplyPatchDeleteFileOperationParam |
update_file |
OpenAI.ApplyPatchUpdateFileOperationParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ApplyPatchOperationParamType | Yes |
OpenAI.ApplyPatchOperationParamType
| Property | Value |
|---|---|
| Type | string |
| Values | create_filedelete_fileupdate_file |
OpenAI.ApplyPatchToolParam
Apply patch tool
Allows the assistant to create, delete, or update files using unified diffs.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the tool. Always apply_patch.Possible values: apply_patch |
Yes | apply_patch |
OpenAI.ApplyPatchUpdateFileOperationParam
Apply patch update file operation
Instruction for updating an existing file via the apply_patch tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| diff | string | Unified diff content to apply to the existing file. Constraints: maxLength: 10485760 |
Yes | |
| path | string | Path of the file to update relative to the workspace root. Constraints: minLength: 1 |
Yes | |
| type | enum | The operation type. Always update_file.Possible values: update_file |
Yes | update_file |
OpenAI.ApproximateLocation
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| city | string or null | No | ||
| country | string or null | No | ||
| region | string or null | No | ||
| timezone | string or null | No | ||
| type | enum | The type of location approximation. Always approximate.Possible values: approximate |
Yes | approximate |
OpenAI.AutoCodeInterpreterToolParam
Automatic Code Interpreter Tool Parameters
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_ids | array of string | An optional list of uploaded files to make available to your code. Constraints: maxItems: 50 |
No | |
| memory_limit | OpenAI.ContainerMemoryLimit or null | No | ||
| network_policy | OpenAI.ContainerNetworkPolicyParam | Network access policy for the container. | No | |
| type | enum | Always auto.Possible values: auto |
Yes | auto |
OpenAI.ChatCompletionTool
Function tool
A function tool that can be used to generate a response.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| function | OpenAI.FunctionObject | Yes | ||
| type | enum | The type of the tool. Currently, only function is supported.Possible values: function |
Yes |
OpenAI.ClickButtonType
| Property | Value |
|---|---|
| Type | string |
| Values | leftrightwheelbackforward |
OpenAI.ClickParam
Click
A click action.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| button | OpenAI.ClickButtonType | Yes | ||
| keys | array of string or null | No | ||
| type | enum | Specifies the event type. For a click action, this property is always click.Possible values: click |
Yes | click |
| x | integer | The x-coordinate where the click occurred. | Yes | |
| y | integer | The y-coordinate where the click occurred. | Yes |
OpenAI.CodeInterpreterOutputImage
Code interpreter output image
The image output from the code interpreter.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the output. Always image.Possible values: image |
Yes | image |
| url | string (uri) | The URL of the image output from the code interpreter. | Yes |
OpenAI.CodeInterpreterOutputLogs
Code interpreter output logs
The logs output from the code interpreter.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| logs | string | The logs output from the code interpreter. | Yes | |
| type | enum | The type of the output. Always logs.Possible values: logs |
Yes | logs |
OpenAI.CodeInterpreterTool
Code interpreter
A tool that runs Python code to help generate a response to a prompt.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container | string or OpenAI.AutoCodeInterpreterToolParam | The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional memory_limit setting. |
Yes | |
| type | enum | The type of the code interpreter tool. Always code_interpreter.Possible values: code_interpreter |
Yes |
OpenAI.ComparisonFilter
Comparison Filter
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| key | string | The key to compare against the value. | Yes | |
| type | enum | Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.- eq: equals- ne: not equal- gt: greater than- gte: greater than or equal- lt: less than- lte: less than or equal- in: in- nin: not inPossible values: eq, ne, gt, gte, lt, lte, in, nin |
Yes | eq |
| value | string or number or boolean or array of string or number | The value to compare against the attribute key; supports string, number, or boolean types. | Yes |
OpenAI.CompoundFilter
Compound Filter
Combine multiple filters using and or or.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filters | array of OpenAI.ComparisonFilter or object | Array of filters to combine. Items can be ComparisonFilter or CompoundFilter. |
Yes | |
| type | enum | Type of operation: and or or.Possible values: and, or |
Yes |
OpenAI.ComputerAction
Discriminator for OpenAI.ComputerAction
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
click |
OpenAI.ClickParam |
double_click |
OpenAI.DoubleClickAction |
drag |
OpenAI.DragParam |
keypress |
OpenAI.KeyPressAction |
move |
OpenAI.MoveParam |
screenshot |
OpenAI.ScreenshotParam |
scroll |
OpenAI.ScrollParam |
type |
OpenAI.TypeParam |
wait |
OpenAI.WaitParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ComputerActionType | Yes |
OpenAI.ComputerActionList
Computer Action List
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
Array of: OpenAI.ComputerAction
OpenAI.ComputerActionType
| Property | Value |
|---|---|
| Type | string |
| Values | clickdouble_clickdragkeypressmovescreenshotscrolltypewait |
OpenAI.ComputerCallSafetyCheckParam
A pending safety check for the computer call.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | No | ||
| id | string | The ID of the pending safety check. | Yes | |
| message | string or null | No |
OpenAI.ComputerEnvironment
| Property | Value |
|---|---|
| Type | string |
| Values | windowsmaclinuxubuntubrowser |
OpenAI.ComputerScreenshotContent
Computer screenshot
A screenshot of a computer.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.ImageDetail | Yes | ||
| file_id | string or null | Yes | ||
| image_url | string or null | Yes | ||
| type | enum | Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.Possible values: computer_screenshot |
Yes | computer_screenshot |
OpenAI.ComputerScreenshotImage
A computer screenshot image used with the computer use tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_id | string | The identifier of an uploaded file that contains the screenshot. | No | |
| image_url | string (uri) | The URL of the screenshot image. | No | |
| type | enum | Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.Possible values: computer_screenshot |
Yes | computer_screenshot |
OpenAI.ComputerTool
Computer
A tool that controls a virtual computer.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the computer tool. Always computer.Possible values: computer |
Yes | computer |
OpenAI.ComputerUsePreviewTool
Computer use preview
A tool that controls a virtual computer.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| display_height | integer | The height of the computer display. | Yes | |
| display_width | integer | The width of the computer display. | Yes | |
| environment | OpenAI.ComputerEnvironment | Yes | ||
| type | enum | The type of the computer use tool. Always computer_use_preview.Possible values: computer_use_preview |
Yes | computer_use_preview |
OpenAI.ContainerAutoParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_ids | array of string | An optional list of uploaded files to make available to your code. Constraints: maxItems: 50 |
No | |
| memory_limit | OpenAI.ContainerMemoryLimit or null | No | ||
| network_policy | OpenAI.ContainerNetworkPolicyParam | Network access policy for the container. | No | |
| skills | array of OpenAI.ContainerSkill | An optional list of skills referenced by id or inline data. Constraints: maxItems: 200 |
No | |
| type | enum | Automatically creates a container for this request Possible values: container_auto |
Yes | container_auto |
OpenAI.ContainerFileCitationBody
Container file citation
A citation for a container file used to generate a model response.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container_id | string | The ID of the container file. | Yes | |
| end_index | integer | The index of the last character of the container file citation in the message. | Yes | |
| file_id | string | The ID of the file. | Yes | |
| filename | string | The filename of the container file cited. | Yes | |
| start_index | integer | The index of the first character of the container file citation in the message. | Yes | |
| type | enum | The type of the container file citation. Always container_file_citation.Possible values: container_file_citation |
Yes | container_file_citation |
OpenAI.ContainerMemoryLimit
| Property | Value |
|---|---|
| Type | string |
| Values | 1g4g16g64g |
OpenAI.ContainerNetworkPolicyAllowlistParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| allowed_domains | array of string | A list of allowed domains when type is allowlist.Constraints: minItems: 1 |
Yes | |
| type | enum | Allow outbound network access only to specified domains. Always allowlist.Possible values: allowlist |
Yes | allowlist |
OpenAI.ContainerNetworkPolicyDisabledParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Disable outbound network access. Always disabled.Possible values: disabled |
Yes | disabled |
OpenAI.ContainerNetworkPolicyParam
Network access policy for the container.
Discriminator for OpenAI.ContainerNetworkPolicyParam
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
disabled |
OpenAI.ContainerNetworkPolicyDisabledParam |
allowlist |
OpenAI.ContainerNetworkPolicyAllowlistParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ContainerNetworkPolicyParamType | Yes |
OpenAI.ContainerNetworkPolicyParamType
| Property | Value |
|---|---|
| Type | string |
| Values | disabledallowlist |
OpenAI.ContainerSkill
Discriminator for OpenAI.ContainerSkill
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
skill_reference |
OpenAI.SkillReferenceParam |
inline |
OpenAI.InlineSkillParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ContainerSkillType | Yes |
OpenAI.ContainerSkillType
| Property | Value |
|---|---|
| Type | string |
| Values | skill_referenceinline |
OpenAI.CoordParam
Coordinate
An x/y coordinate pair, e.g. { x: 100, y: 200 }.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| x | integer | The x-coordinate. | Yes | |
| y | integer | The y-coordinate. | Yes |
OpenAI.CreateChatCompletionRequestResponseFormat
An object specifying the format that the model must output.
Setting to { "type": "json_schema", "json_schema": {...} } enables
Structured Outputs which ensures the model will match your supplied JSON
schema. Learn more in the Structured Outputs guide.
Setting to { "type": "json_object" } enables the older JSON mode, which
ensures the message the model generates is valid JSON. Using json_schema
is preferred for models that support it.
Discriminator for OpenAI.CreateChatCompletionRequestResponseFormat
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
json_schema |
OpenAI.ResponseFormatJsonSchema |
text |
OpenAI.CreateChatCompletionRequestResponseFormatResponseFormatText |
json_object |
OpenAI.CreateChatCompletionRequestResponseFormatResponseFormatJsonObject |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.CreateChatCompletionRequestResponseFormatType | Yes |
OpenAI.CreateChatCompletionRequestResponseFormatResponseFormatJsonObject
JSON object
JSON object response format. An older method of generating JSON responses.
Using json_schema is recommended for models that support it. Note that the
model will not generate JSON without a system or user message instructing it
to do so.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined. Always json_object.Possible values: json_object |
Yes |
OpenAI.CreateChatCompletionRequestResponseFormatResponseFormatText
Text
Default response format. Used to generate text responses.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined. Always text.Possible values: text |
Yes |
OpenAI.CreateChatCompletionRequestResponseFormatType
| Property | Value |
|---|---|
| Type | string |
| Values | textjson_schemajson_object |
OpenAI.CreateEvalCompletionsRunDataSource
CompletionsRunDataSource
A CompletionsRunDataSource object describing a model sampling configuration.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input_messages | OpenAI.CreateEvalCompletionsRunDataSourceInputMessagesTemplate or OpenAI.CreateEvalCompletionsRunDataSourceInputMessagesItemReference | Used when sampling from a model. Dictates the structure of the messages passed into the model. Can either be a reference to a prebuilt trajectory (ie, item.input_trajectory), or a template with variable references to the item namespace. |
No | |
| model | string | The name of the model to use for generating completions (e.g. "o3-mini"). | No | |
| sampling_params | AzureCompletionsSamplingParams | Sampling parameters for controlling the behavior of completions. | No | |
| source | OpenAI.EvalJsonlFileContentSource or OpenAI.EvalJsonlFileIdSource or OpenAI.EvalStoredCompletionsSource | Determines what populates the item namespace in this run's data source. |
Yes | |
| type | enum | The type of run data source. Always completions.Possible values: completions |
Yes | completions |
OpenAI.CreateEvalCompletionsRunDataSourceInputMessagesItemReference
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| item_reference | string | Yes | ||
| type | enum | Possible values: item_reference |
Yes |
OpenAI.CreateEvalCompletionsRunDataSourceInputMessagesTemplate
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| template | array of OpenAI.EasyInputMessage or OpenAI.EvalItem | Yes | ||
| type | enum | Possible values: template |
Yes |
OpenAI.CreateEvalCompletionsRunDataSourceSamplingParams
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| max_completion_tokens | integer | No | ||
| reasoning_effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| response_format | OpenAI.ResponseFormatText or OpenAI.ResponseFormatJsonSchema or OpenAI.ResponseFormatJsonObject | No | ||
| seed | integer | A seed value initializes the randomness during sampling. | No | 42 |
| temperature | number | A higher temperature increases randomness in the outputs. | No | 1 |
| tools | array of OpenAI.ChatCompletionTool | No | ||
| top_p | number | An alternative to temperature for nucleus sampling; 1.0 includes all tokens. | No | 1 |
OpenAI.CreateEvalCustomDataSourceConfig
CustomDataSourceConfig
A CustomDataSourceConfig object that defines the schema for the data source used for the evaluation runs. This schema is used to define the shape of the data that will be:
- Used to define your testing criteria and
- What data is required when creating a run
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| include_sample_schema | boolean | Whether the eval should expect you to populate the sample namespace (ie, by generating responses off of your data source) | No | |
| item_schema | object | The json schema for each row in the data source. | Yes | |
| type | enum | The type of data source. Always custom.Possible values: custom |
Yes | custom |
OpenAI.CreateEvalItem
CreateEvalItem
A chat message that makes up the prompt or context. May include variable references to the item namespace, ie {{item.name}}.
This component can be one of the following:
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string | Yes | ||
| role | string | Yes |
OpenAI.CreateEvalJsonlRunDataSource
JsonlRunDataSource
A JsonlRunDataSource object with that specifies a JSONL file that matches the eval
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| source | OpenAI.EvalJsonlFileContentSource or OpenAI.EvalJsonlFileIdSource | Determines what populates the item namespace in the data source. |
Yes | |
| type | enum | The type of data source. Always jsonl.Possible values: jsonl |
Yes | jsonl |
OpenAI.CreateEvalLabelModelGrader
LabelModelGrader
A LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input | array of OpenAI.CreateEvalItem | A list of chat messages forming the prompt or context. May include variable references to the item namespace, ie {{item.name}}. |
Yes | |
| labels | array of string | The labels to classify to each item in the evaluation. | Yes | |
| model | string | The model to use for the evaluation. Must support structured outputs. | Yes | |
| name | string | The name of the grader. | Yes | |
| passing_labels | array of string | The labels that indicate a passing result. Must be a subset of labels. | Yes | |
| type | enum | The object type, which is always label_model.Possible values: label_model |
Yes |
OpenAI.CreateEvalLogsDataSourceConfig
LogsDataSourceConfig
A data source config which specifies the metadata property of your logs query.
This is usually metadata like usecase=chatbot or prompt-version=v2, etc.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| metadata | object | Metadata filters for the logs data source. | No | |
| type | enum | The type of data source. Always logs.Possible values: logs |
Yes | logs |
OpenAI.CreateEvalResponsesRunDataSource
ResponsesRunDataSource
A ResponsesRunDataSource object describing a model sampling configuration.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input_messages | OpenAI.CreateEvalResponsesRunDataSourceInputMessagesTemplate or OpenAI.CreateEvalResponsesRunDataSourceInputMessagesItemReference | Used when sampling from a model. Dictates the structure of the messages passed into the model. Can either be a reference to a prebuilt trajectory (ie, item.input_trajectory), or a template with variable references to the item namespace. |
No | |
| model | string | The name of the model to use for generating completions (e.g. "o3-mini"). | No | |
| sampling_params | AzureResponsesSamplingParams | Sampling parameters for controlling the behavior of responses. | No | |
| source | OpenAI.EvalJsonlFileContentSource or OpenAI.EvalJsonlFileIdSource or OpenAI.EvalResponsesSource | Determines what populates the item namespace in this run's data source. |
Yes | |
| type | enum | The type of run data source. Always responses.Possible values: responses |
Yes | responses |
OpenAI.CreateEvalResponsesRunDataSourceInputMessagesItemReference
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| item_reference | string | Yes | ||
| type | enum | Possible values: item_reference |
Yes |
OpenAI.CreateEvalResponsesRunDataSourceInputMessagesTemplate
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| template | array of object or OpenAI.EvalItem | Yes | ||
| type | enum | Possible values: template |
Yes |
OpenAI.CreateEvalResponsesRunDataSourceSamplingParams
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| reasoning_effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| seed | integer | A seed value initializes the randomness during sampling. | No | 42 |
| temperature | number | A higher temperature increases randomness in the outputs. | No | 1 |
| text | OpenAI.CreateEvalResponsesRunDataSourceSamplingParamsText | No | ||
| tools | array of OpenAI.Tool | No | ||
| top_p | number | An alternative to temperature for nucleus sampling; 1.0 includes all tokens. | No | 1 |
OpenAI.CreateEvalResponsesRunDataSourceSamplingParamsText
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| format | OpenAI.TextResponseFormatConfiguration | An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs,which ensures the model will match your supplied JSON schema. Learn more in the The default format is { "type": "text" } with no additional options.Not recommended for gpt-4o and newer models: Setting to { "type": "json_object" } enables the older JSON mode, whichensures the message the model generates is valid JSON. Using json_schemais preferred for models that support it. |
No |
OpenAI.CreateEvalRunRequest
CreateEvalRunRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data_source | OpenAI.CreateEvalJsonlRunDataSource or OpenAI.CreateEvalCompletionsRunDataSource or OpenAI.CreateEvalResponsesRunDataSource | Details about the run's data source. | Yes | |
| metadata | OpenAI.Metadata or null | No | ||
| name | string | The name of the run. | No |
OpenAI.CreateEvalStoredCompletionsDataSourceConfig
StoredCompletionsDataSourceConfig
Deprecated in favor of LogsDataSourceConfig.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| metadata | object | Metadata filters for the stored completions data source. | No | |
| type | enum | The type of data source. Always stored_completions.Possible values: stored_completions |
Yes | stored_completions |
OpenAI.CustomGrammarFormatParam
Grammar format
A grammar defined by the user.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | string | The grammar definition. | Yes | |
| syntax | OpenAI.GrammarSyntax1 | Yes | ||
| type | enum | Grammar format. Always grammar.Possible values: grammar |
Yes | grammar |
OpenAI.CustomTextFormatParam
Text format
Unconstrained free-form text.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Unconstrained text format. Always text.Possible values: text |
Yes | text |
OpenAI.CustomToolParam
Custom tool
A custom tool that processes input using a specified format. Learn more about custom tools
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| defer_loading | boolean | Whether this tool should be deferred and discovered via tool search. | No | |
| description | string | Optional description of the custom tool, used to provide more context. | No | |
| format | OpenAI.CustomToolParamFormat | The input format for the custom tool. Default is unconstrained text. | No | |
| └─ type | OpenAI.CustomToolParamFormatType | Yes | ||
| name | string | The name of the custom tool, used to identify it in tool calls. | Yes | |
| type | enum | The type of the custom tool. Always custom.Possible values: custom |
Yes | custom |
OpenAI.CustomToolParamFormat
The input format for the custom tool. Default is unconstrained text.
Discriminator for OpenAI.CustomToolParamFormat
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
text |
OpenAI.CustomTextFormatParam |
grammar |
OpenAI.CustomGrammarFormatParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.CustomToolParamFormatType | Yes |
OpenAI.CustomToolParamFormatType
| Property | Value |
|---|---|
| Type | string |
| Values | textgrammar |
OpenAI.DetailEnum
| Property | Value |
|---|---|
| Type | string |
| Values | lowhighautooriginal |
OpenAI.DoubleClickAction
DoubleClick
A double click action.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| keys | array of string or null | Yes | ||
| type | enum | Specifies the event type. For a double click action, this property is always set to double_click.Possible values: double_click |
Yes | double_click |
| x | integer | The x-coordinate where the double click occurred. | Yes | |
| y | integer | The y-coordinate where the double click occurred. | Yes |
OpenAI.DragParam
Drag
A drag action.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| keys | array of string or null | No | ||
| path | array of OpenAI.CoordParam | An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg<br> [ { x: 100, y: 200 }, { x: 200, y: 300 } ]<br> |
Yes | |
| type | enum | Specifies the event type. For a drag action, this property is always set to drag.Possible values: drag |
Yes | drag |
OpenAI.EasyInputMessage
Input message
A message input to the model with a role indicating instruction following
hierarchy. Instructions given with the developer or system role take
precedence over instructions given with the user role. Messages with the
assistant role are presumed to have been generated by the model in previous
interactions.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string or OpenAI.InputMessageContentList | Text, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses. |
Yes | |
| phase | OpenAI.MessagePhase or null | No | ||
| role | enum | The role of the message input. One of user, assistant, system, ordeveloper.Possible values: user, assistant, system, developer |
Yes | |
| status | enum | The status of item. One of in_progress, completed, orincomplete. Populated when items are returned via API.Possible values: in_progress, completed, incomplete |
No | |
| type | enum | The type of the message input. Always message.Possible values: message |
Yes |
OpenAI.EmptyModelParam
Type: object
OpenAI.Eval
Eval
An Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
- Improve the quality of my chatbot
- See how well my chatbot handles customer support
- Check if o4-mini is better at my usecase than gpt-4o
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created_at | integer (unixtime) | The Unix timestamp (in seconds) for when the eval was created. | Yes | |
| data_source_config | OpenAI.EvalCustomDataSourceConfig or OpenAI.EvalLogsDataSourceConfig or OpenAI.EvalStoredCompletionsDataSourceConfig | Configuration of data sources used in runs of the evaluation. | Yes | |
| id | string | Unique identifier for the evaluation. | Yes | |
| metadata | OpenAI.Metadata or null | Yes | ||
| name | string | The name of the evaluation. | Yes | |
| object | enum | The object type. Possible values: eval |
Yes | eval |
| testing_criteria | array of OpenAI.CreateEvalLabelModelGrader or OpenAI.EvalGraderStringCheck or OpenAI.EvalGraderTextSimilarity or OpenAI.EvalGraderPython or OpenAI.EvalGraderScoreModel or EvalGraderEndpoint | A list of testing criteria. | Yes |
OpenAI.EvalApiError
EvalApiError
An object representing an error response from the Eval API.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string | The error code. | Yes | |
| message | string | The error message. | Yes |
OpenAI.EvalCustomDataSourceConfig
CustomDataSourceConfig
A CustomDataSourceConfig which specifies the schema of your item and optionally sample namespaces.
The response schema defines the shape of the data that will be:
- Used to define your testing criteria and
- What data is required when creating a run
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| schema | object | The json schema for the run data source items. Learn how to build JSON schemas here. |
Yes | |
| type | enum | The type of data source. Always custom.Possible values: custom |
Yes | custom |
OpenAI.EvalGraderPython
PythonGrader
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| image_tag | string | The image tag to use for the python script. | No | |
| name | string | The name of the grader. | Yes | |
| pass_threshold | number | The threshold for the score. | No | |
| source | string | The source code of the python script. | Yes | |
| type | enum | The object type, which is always python.Possible values: python |
Yes |
OpenAI.EvalGraderScoreModel
ScoreModelGrader
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input | array of OpenAI.EvalItem | The input messages evaluated by the grader. Supports text, output text, input image, and input audio content blocks, and may include template strings. | Yes | |
| model | string | The model to use for the evaluation. | Yes | |
| name | string | The name of the grader. | Yes | |
| pass_threshold | number | The threshold for the score. | No | |
| range | array of number | The range of the score. Defaults to [0, 1]. |
No | |
| sampling_params | OpenAI.EvalGraderScoreModelSamplingParams | No | ||
| └─ max_completions_tokens | integer or null | No | ||
| └─ reasoning_effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| └─ seed | integer or null | No | ||
| └─ temperature | number or null | No | ||
| └─ top_p | number or null | No | 1 | |
| type | enum | The object type, which is always score_model.Possible values: score_model |
Yes |
OpenAI.EvalGraderScoreModelSamplingParams
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| max_completions_tokens | integer or null | No | ||
| reasoning_effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| seed | integer or null | No | ||
| temperature | number or null | No | ||
| top_p | number or null | No |
OpenAI.EvalGraderStringCheck
StringCheckGrader
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input | string | The input text. This may include template strings. | Yes | |
| name | string | The name of the grader. | Yes | |
| operation | enum | The string check operation to perform. One of eq, ne, like, or ilike.Possible values: eq, ne, like, ilike |
Yes | |
| reference | string | The reference text. This may include template strings. | Yes | |
| type | enum | The object type, which is always string_check.Possible values: string_check |
Yes |
OpenAI.EvalGraderTextSimilarity
TextSimilarityGrader
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| evaluation_metric | enum | The evaluation metric to use. One of cosine, fuzzy_match, bleu,gleu, meteor, rouge_1, rouge_2, rouge_3, rouge_4, rouge_5,or rouge_l.Possible values: cosine, fuzzy_match, bleu, gleu, meteor, rouge_1, rouge_2, rouge_3, rouge_4, rouge_5, rouge_l |
Yes | |
| input | string | The text being graded. | Yes | |
| name | string | The name of the grader. | Yes | |
| pass_threshold | number | The threshold for the score. | Yes | |
| reference | string | The text being graded against. | Yes | |
| type | enum | The type of grader. Possible values: text_similarity |
Yes | text_similarity |
OpenAI.EvalItem
Eval message object
A message input to the model with a role indicating instruction following
hierarchy. Instructions given with the developer or system role take
precedence over instructions given with the user role. Messages with the
assistant role are presumed to have been generated by the model in previous
interactions.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | OpenAI.EvalItemContent | Inputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items. | Yes | |
| role | enum | The role of the message input. One of user, assistant, system, ordeveloper.Possible values: user, assistant, system, developer |
Yes | |
| type | enum | The type of the message input. Always message.Possible values: message |
No |
OpenAI.EvalItemContent
Eval content
Inputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
This component can be one of the following:
OpenAI.EvalItemContentArray
An array of Input text, Output text, Input image, and Input audio
A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
Array of: OpenAI.EvalItemContentItem
OpenAI.EvalItemContentItem
Eval content item
A single content item: input text, output text, input image, or input audio.
This component can be one of the following:
OpenAI.EvalItemContentItemObject
Eval content item
A single content item: input text, output text, input image, or input audio.
Discriminator for OpenAI.EvalItemContentItemObject
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
output_text |
OpenAI.EvalItemContentOutputText |
input_image |
OpenAI.EvalItemInputImage |
input_audio |
OpenAI.InputAudio |
input_text |
OpenAI.EvalItemContentItemObjectInputTextContent |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.EvalItemContentItemObjectType | Yes |
OpenAI.EvalItemContentItemObjectInputTextContent
Input text
A text input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| text | string | The text input to the model. | Yes | |
| type | enum | The type of the input item. Always input_text.Possible values: input_text |
Yes | input_text |
OpenAI.EvalItemContentItemObjectType
| Property | Value |
|---|---|
| Type | string |
| Values | input_textoutput_textinput_imageinput_audio |
OpenAI.EvalItemContentOutputText
Output text
A text output from the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| text | string | The text output from the model. | Yes | |
| type | enum | The type of the output text. Always output_text.Possible values: output_text |
Yes |
OpenAI.EvalItemContentText
Text input
A text input to the model.
Type: string
OpenAI.EvalItemInputImage
Input image
An image input block used within EvalItem content arrays.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | string | The detail level of the image to be sent to the model. One of high, low, or auto. Defaults to auto. |
No | |
| image_url | string (uri) | The URL of the image input. | Yes | |
| type | enum | The type of the image input. Always input_image.Possible values: input_image |
Yes |
OpenAI.EvalJsonlFileContentSource
EvalJsonlFileContentSource
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | array of OpenAI.EvalJsonlFileContentSourceContent | The content of the jsonl file. | Yes | |
| type | enum | The type of jsonl source. Always file_content.Possible values: file_content |
Yes | file_content |
OpenAI.EvalJsonlFileContentSourceContent
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| item | object | Yes | ||
| sample | object | No |
OpenAI.EvalJsonlFileIdSource
EvalJsonlFileIdSource
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | string | The identifier of the file. | Yes | |
| type | enum | The type of jsonl source. Always file_id.Possible values: file_id |
Yes | file_id |
OpenAI.EvalList
EvalList
An object representing a list of evals.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | array of OpenAI.Eval | An array of eval objects. | Yes | |
| first_id | string | The identifier of the first eval in the data array. | Yes | |
| has_more | boolean | Indicates whether there are more evals available. | Yes | |
| last_id | string | The identifier of the last eval in the data array. | Yes | |
| object | enum | The type of this object. It is always set to "list". Possible values: list |
Yes | list |
OpenAI.EvalLogsDataSourceConfig
LogsDataSourceConfig
A LogsDataSourceConfig which specifies the metadata property of your logs query.
This is usually metadata like usecase=chatbot or prompt-version=v2, etc.
The schema returned by this data source config is used to defined what variables are available in your evals.
item and sample are both defined when using this data source config.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| metadata | OpenAI.Metadata or null | No | ||
| schema | object | The json schema for the run data source items. Learn how to build JSON schemas here. |
Yes | |
| type | enum | The type of data source. Always logs.Possible values: logs |
Yes | logs |
OpenAI.EvalResponsesSource
EvalResponsesSource
A EvalResponsesSource object describing a run data source configuration.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created_after | integer or null | No | ||
| created_before | integer or null | No | ||
| instructions_search | string or null | No | ||
| metadata | object or null | No | ||
| model | string or null | No | ||
| reasoning_effort | OpenAI.ReasoningEffort or null | No | ||
| temperature | number or null | No | ||
| tools | array of string or null | No | ||
| top_p | number or null | No | ||
| type | enum | The type of run data source. Always responses.Possible values: responses |
Yes | |
| users | array of string or null | No |
OpenAI.EvalRun
EvalRun
A schema representing an evaluation run.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created_at | integer (unixtime) | Unix timestamp (in seconds) when the evaluation run was created. | Yes | |
| data_source | OpenAI.CreateEvalJsonlRunDataSource or OpenAI.CreateEvalCompletionsRunDataSource or OpenAI.CreateEvalResponsesRunDataSource | Information about the run's data source. | Yes | |
| error | OpenAI.EvalApiError | An object representing an error response from the Eval API. | Yes | |
| eval_id | string | The identifier of the associated evaluation. | Yes | |
| id | string | Unique identifier for the evaluation run. | Yes | |
| metadata | OpenAI.Metadata or null | Yes | ||
| model | string | The model that is evaluated, if applicable. | Yes | |
| name | string | The name of the evaluation run. | Yes | |
| object | enum | The type of the object. Always "eval.run". Possible values: eval.run |
Yes | eval.run |
| per_model_usage | array of OpenAI.EvalRunPerModelUsage | Usage statistics for each model during the evaluation run. | Yes | |
| per_testing_criteria_results | array of OpenAI.EvalRunPerTestingCriteriaResults | Results per testing criteria applied during the evaluation run. | Yes | |
| report_url | string (uri) | The URL to the rendered evaluation run report on the UI dashboard. | Yes | |
| result_counts | OpenAI.EvalRunResultCounts | Yes | ||
| └─ errored | integer | Yes | ||
| └─ failed | integer | Yes | ||
| └─ passed | integer | Yes | ||
| └─ total | integer | Yes | ||
| status | string | The status of the evaluation run. | Yes |
OpenAI.EvalRunList
EvalRunList
An object representing a list of runs for an evaluation.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | array of OpenAI.EvalRun | An array of eval run objects. | Yes | |
| first_id | string | The identifier of the first eval run in the data array. | Yes | |
| has_more | boolean | Indicates whether there are more evals available. | Yes | |
| last_id | string | The identifier of the last eval run in the data array. | Yes | |
| object | enum | The type of this object. It is always set to "list". Possible values: list |
Yes | list |
OpenAI.EvalRunOutputItem
EvalRunOutputItem
A schema representing an evaluation run output item.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created_at | integer (unixtime) | Unix timestamp (in seconds) when the evaluation run was created. | Yes | |
| datasource_item | object | Details of the input data source item. | Yes | |
| datasource_item_id | integer | The identifier for the data source item. | Yes | |
| eval_id | string | The identifier of the evaluation group. | Yes | |
| id | string | Unique identifier for the evaluation run output item. | Yes | |
| object | enum | The type of the object. Always "eval.run.output_item". Possible values: eval.run.output_item |
Yes | eval.run.output_item |
| results | array of OpenAI.EvalRunOutputItemResult | A list of grader results for this output item. | Yes | |
| run_id | string | The identifier of the evaluation run associated with this output item. | Yes | |
| sample | OpenAI.EvalRunOutputItemSample | Yes | ||
| └─ error | OpenAI.EvalApiError | An object representing an error response from the Eval API. | Yes | |
| └─ finish_reason | string | Yes | ||
| └─ input | array of OpenAI.EvalRunOutputItemSampleInput | Yes | ||
| └─ max_completion_tokens | integer | Yes | ||
| └─ model | string | Yes | ||
| └─ output | array of OpenAI.EvalRunOutputItemSampleOutput | Yes | ||
| └─ seed | integer | Yes | ||
| └─ temperature | number | Yes | ||
| └─ top_p | number | Yes | ||
| └─ usage | OpenAI.EvalRunOutputItemSampleUsage | Yes | ||
| status | string | The status of the evaluation run. | Yes |
OpenAI.EvalRunOutputItemList
EvalRunOutputItemList
An object representing a list of output items for an evaluation run.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | array of OpenAI.EvalRunOutputItem | An array of eval run output item objects. | Yes | |
| first_id | string | The identifier of the first eval run output item in the data array. | Yes | |
| has_more | boolean | Indicates whether there are more eval run output items available. | Yes | |
| last_id | string | The identifier of the last eval run output item in the data array. | Yes | |
| object | enum | The type of this object. It is always set to "list". Possible values: list |
Yes | list |
OpenAI.EvalRunOutputItemResult
EvalRunOutputItemResult
A single grader result for an evaluation run output item.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| name | string | The name of the grader. | Yes | |
| passed | boolean | Whether the grader considered the output a pass. | Yes | |
| sample | object or null | Optional sample or intermediate data produced by the grader. | No | |
| score | number | The numeric score produced by the grader. | Yes | |
| type | string | The grader type (for example, "string-check-grader"). | No |
OpenAI.EvalRunOutputItemSample
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| error | OpenAI.EvalApiError | An object representing an error response from the Eval API. | Yes | |
| finish_reason | string | Yes | ||
| input | array of OpenAI.EvalRunOutputItemSampleInput | Yes | ||
| max_completion_tokens | integer | Yes | ||
| model | string | Yes | ||
| output | array of OpenAI.EvalRunOutputItemSampleOutput | Yes | ||
| seed | integer | Yes | ||
| temperature | number | Yes | ||
| top_p | number | Yes | ||
| usage | OpenAI.EvalRunOutputItemSampleUsage | Yes |
OpenAI.EvalRunOutputItemSampleInput
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string | Yes | ||
| role | string | Yes |
OpenAI.EvalRunOutputItemSampleOutput
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| content | string | No | ||
| role | string | No |
OpenAI.EvalRunOutputItemSampleUsage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| cached_tokens | integer | Yes | ||
| completion_tokens | integer | Yes | ||
| prompt_tokens | integer | Yes | ||
| total_tokens | integer | Yes |
OpenAI.EvalRunPerModelUsage
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| cached_tokens | integer | Yes | ||
| completion_tokens | integer | Yes | ||
| invocation_count | integer | Yes | ||
| model_name | string | Yes | ||
| prompt_tokens | integer | Yes | ||
| total_tokens | integer | Yes |
OpenAI.EvalRunPerTestingCriteriaResults
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| failed | integer | Yes | ||
| passed | integer | Yes | ||
| testing_criteria | string | Yes |
OpenAI.EvalRunResultCounts
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| errored | integer | Yes | ||
| failed | integer | Yes | ||
| passed | integer | Yes | ||
| total | integer | Yes |
OpenAI.EvalStoredCompletionsDataSourceConfig
StoredCompletionsDataSourceConfig
Deprecated in favor of LogsDataSourceConfig.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| metadata | OpenAI.Metadata or null | No | ||
| schema | object | The json schema for the run data source items. Learn how to build JSON schemas here. |
Yes | |
| type | enum | The type of data source. Always stored_completions.Possible values: stored_completions |
Yes | stored_completions |
OpenAI.EvalStoredCompletionsSource
StoredCompletionsRunDataSource
A StoredCompletionsRunDataSource configuration describing a set of filters
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created_after | integer or null | No | ||
| created_before | integer or null | No | ||
| limit | integer or null | No | ||
| metadata | OpenAI.Metadata or null | No | ||
| model | string or null | No | ||
| type | enum | The type of source. Always stored_completions.Possible values: stored_completions |
Yes | stored_completions |
OpenAI.FileCitationBody
File citation
A citation to a file.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_id | string | The ID of the file. | Yes | |
| filename | string | The filename of the file cited. | Yes | |
| index | integer | The index of the file in the list of files. | Yes | |
| type | enum | The type of the file citation. Always file_citation.Possible values: file_citation |
Yes | file_citation |
OpenAI.FileInputDetail
| Property | Value |
|---|---|
| Type | string |
| Values | lowhigh |
OpenAI.FilePath
File path
A path to a file.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_id | string | The ID of the file. | Yes | |
| index | integer | The index of the file in the list of files. | Yes | |
| type | enum | The type of the file path. Always file_path.Possible values: file_path |
Yes |
OpenAI.FileSearchTool
File search
A tool that searches for relevant content from uploaded files.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filters | OpenAI.Filters or null | No | ||
| max_num_results | integer | The maximum number of results to return. This number should be between 1 and 50 inclusive. | No | |
| ranking_options | OpenAI.RankingOptions | No | ||
| └─ hybrid_search | OpenAI.HybridSearchOptions | Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled. | No | |
| └─ ranker | OpenAI.RankerVersionType | The ranker to use for the file search. | No | |
| └─ score_threshold | number | The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results. | No | |
| type | enum | The type of the file search tool. Always file_search.Possible values: file_search |
Yes | file_search |
| vector_store_ids | array of string | The IDs of the vector stores to search. | Yes |
OpenAI.FileSearchToolCallResults
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| attributes | OpenAI.VectorStoreFileAttributes or null | No | ||
| file_id | string | No | ||
| filename | string | No | ||
| score | number (float) | No | ||
| text | string | No |
OpenAI.Filters
Type: OpenAI.ComparisonFilter or OpenAI.CompoundFilter
OpenAI.FunctionAndCustomToolCallOutput
Discriminator for OpenAI.FunctionAndCustomToolCallOutput
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
input_text |
OpenAI.FunctionAndCustomToolCallOutputInputTextContent |
input_image |
OpenAI.FunctionAndCustomToolCallOutputInputImageContent |
input_file |
OpenAI.FunctionAndCustomToolCallOutputInputFileContent |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.FunctionAndCustomToolCallOutputType | Yes |
OpenAI.FunctionAndCustomToolCallOutputInputFileContent
Input file
A file input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.FileInputDetail | No | ||
| file_data | string | The content of the file to be sent to the model. | No | |
| file_id | string or null | No | ||
| file_url | string (uri) | The URL of the file to be sent to the model. | No | |
| filename | string | The name of the file to be sent to the model. | No | |
| type | enum | The type of the input item. Always input_file.Possible values: input_file |
Yes | input_file |
OpenAI.FunctionAndCustomToolCallOutputInputImageContent
Input image
An image input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.ImageDetail | Yes | ||
| file_id | string or null | No | ||
| image_url | string or null | No | ||
| type | enum | The type of the input item. Always input_image.Possible values: input_image |
Yes | input_image |
OpenAI.FunctionAndCustomToolCallOutputInputTextContent
Input text
A text input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| text | string | The text input to the model. | Yes | |
| type | enum | The type of the input item. Always input_text.Possible values: input_text |
Yes | input_text |
OpenAI.FunctionAndCustomToolCallOutputType
| Property | Value |
|---|---|
| Type | string |
| Values | input_textinput_imageinput_file |
OpenAI.FunctionCallItemStatus
| Property | Value |
|---|---|
| Type | string |
| Values | in_progresscompletedincomplete |
OpenAI.FunctionObject
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| name | string | The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64. | Yes | |
| parameters | OpenAI.FunctionParameters | The parameters the functions accepts, described as a JSON Schema object. See the JSON Schema reference for documentation about the format. Omitting parameters defines a function with an empty parameter list. |
No | |
| strict | boolean or null | No |
OpenAI.FunctionParameters
The parameters the functions accepts, described as a JSON Schema object. See the JSON Schema reference for documentation about the format.
Omitting parameters defines a function with an empty parameter list.
Type: object
OpenAI.FunctionShellActionParam
Shell action
Commands and limits describing how to run the shell tool call.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| commands | array of string | Ordered shell commands for the execution environment to run. | Yes | |
| max_output_length | integer or null | No | ||
| timeout_ms | integer or null | No |
OpenAI.FunctionShellCallItemParamEnvironment
The environment to execute the shell commands in.
Discriminator for OpenAI.FunctionShellCallItemParamEnvironment
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
local |
OpenAI.FunctionShellCallItemParamEnvironmentLocalEnvironmentParam |
container_reference |
OpenAI.FunctionShellCallItemParamEnvironmentContainerReferenceParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.FunctionShellCallItemParamEnvironmentType | Yes |
OpenAI.FunctionShellCallItemParamEnvironmentContainerReferenceParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container_id | string | The ID of the referenced container. | Yes | |
| type | enum | References a container created with the /v1/containers endpoint Possible values: container_reference |
Yes | container_reference |
OpenAI.FunctionShellCallItemParamEnvironmentLocalEnvironmentParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| skills | array of OpenAI.LocalSkillParam | An optional list of skills. Constraints: maxItems: 200 |
No | |
| type | enum | Use a local computer environment. Possible values: local |
Yes | local |
OpenAI.FunctionShellCallItemParamEnvironmentType
| Property | Value |
|---|---|
| Type | string |
| Values | localcontainer_reference |
OpenAI.FunctionShellCallItemStatus
Shell call status
Status values reported for shell tool calls.
| Property | Value |
|---|---|
| Type | string |
| Values | in_progresscompletedincomplete |
OpenAI.FunctionShellCallOutputContentParam
Shell output content
Captured stdout and stderr for a portion of a shell tool call output.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| outcome | OpenAI.FunctionShellCallOutputOutcomeParam | The exit or timeout outcome associated with this shell call. | Yes | |
| └─ type | OpenAI.FunctionShellCallOutputOutcomeParamType | Yes | ||
| stderr | string | Captured stderr output for the shell call. Constraints: maxLength: 10485760 |
Yes | |
| stdout | string | Captured stdout output for the shell call. Constraints: maxLength: 10485760 |
Yes |
OpenAI.FunctionShellCallOutputExitOutcomeParam
Shell call exit outcome
Indicates that the shell commands finished and returned an exit code.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| exit_code | integer | The exit code returned by the shell process. | Yes | |
| type | enum | The outcome type. Always exit.Possible values: exit |
Yes | exit |
OpenAI.FunctionShellCallOutputOutcomeParam
Shell call outcome
The exit or timeout outcome associated with this shell call.
Discriminator for OpenAI.FunctionShellCallOutputOutcomeParam
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
timeout |
OpenAI.FunctionShellCallOutputTimeoutOutcomeParam |
exit |
OpenAI.FunctionShellCallOutputExitOutcomeParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.FunctionShellCallOutputOutcomeParamType | Yes |
OpenAI.FunctionShellCallOutputOutcomeParamType
| Property | Value |
|---|---|
| Type | string |
| Values | timeoutexit |
OpenAI.FunctionShellCallOutputTimeoutOutcomeParam
Shell call timeout outcome
Indicates that the shell call exceeded its configured time limit.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The outcome type. Always timeout.Possible values: timeout |
Yes | timeout |
OpenAI.FunctionShellToolParam
Shell tool
A tool that allows the model to execute shell commands.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| environment | OpenAI.FunctionShellToolParamEnvironment or null | No | ||
| type | enum | The type of the shell tool. Always shell.Possible values: shell |
Yes | shell |
OpenAI.FunctionShellToolParamEnvironment
Discriminator for OpenAI.FunctionShellToolParamEnvironment
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
local |
OpenAI.FunctionShellToolParamEnvironmentLocalEnvironmentParam |
container_reference |
OpenAI.FunctionShellToolParamEnvironmentContainerReferenceParam |
container_auto |
OpenAI.ContainerAutoParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.FunctionShellToolParamEnvironmentType | Yes |
OpenAI.FunctionShellToolParamEnvironmentContainerReferenceParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container_id | string | The ID of the referenced container. | Yes | |
| type | enum | References a container created with the /v1/containers endpoint Possible values: container_reference |
Yes | container_reference |
OpenAI.FunctionShellToolParamEnvironmentLocalEnvironmentParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| skills | array of OpenAI.LocalSkillParam | An optional list of skills. Constraints: maxItems: 200 |
No | |
| type | enum | Use a local computer environment. Possible values: local |
Yes | local |
OpenAI.FunctionShellToolParamEnvironmentType
| Property | Value |
|---|---|
| Type | string |
| Values | container_autolocalcontainer_reference |
OpenAI.FunctionTool
Function
Defines a function in your own code the model can choose to call.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| defer_loading | boolean | Whether this function is deferred and loaded via tool search. | No | |
| description | string or null | No | ||
| name | string | The name of the function to call. | Yes | |
| parameters | object or null | Yes | ||
| strict | boolean or null | Yes | ||
| type | enum | The type of the function tool. Always function.Possible values: function |
Yes | function |
OpenAI.FunctionToolParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| defer_loading | boolean | Whether this function should be deferred and discovered via tool search. | No | |
| description | string or null | No | ||
| name | string | Constraints: minLength: 1, maxLength: 128, pattern: ^[a-zA-Z0-9_-]+$ |
Yes | |
| parameters | OpenAI.EmptyModelParam or null | No | ||
| strict | boolean or null | No | ||
| type | enum | Possible values: function |
Yes | function |
OpenAI.GrammarSyntax1
| Property | Value |
|---|---|
| Type | string |
| Values | larkregex |
OpenAI.HybridSearchOptions
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| embedding_weight | number | The weight of the embedding in the reciprocal ranking fusion. | Yes | |
| text_weight | number | The weight of the text in the reciprocal ranking fusion. | Yes |
OpenAI.ImageDetail
| Property | Value |
|---|---|
| Type | string |
| Values | lowhighautooriginal |
OpenAI.ImageGenActionEnum
| Property | Value |
|---|---|
| Type | string |
| Values | generateeditauto |
OpenAI.ImageGenTool
Image generation tool
A tool that generates images using the GPT image models.
Valid models:
gpt-image-1
gpt-image-1-mini
gpt-image-1.5
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| action | OpenAI.ImageGenActionEnum | No | ||
| background | enum | Background type for the generated image. One of transparent,opaque, or auto. Default: auto.Possible values: transparent, opaque, auto |
No | auto |
| input_fidelity | OpenAI.InputFidelity or null | No | ||
| input_image_mask | OpenAI.ImageGenToolInputImageMask | No | ||
| └─ file_id | string | No | ||
| └─ image_url | string (uri) | No | ||
| model | string (see valid models below) | No | ||
| moderation | enum | Moderation level for the generated image. Default: auto.Possible values: auto, low |
No | auto |
| output_compression | integer | Compression level for the output image. Default: 100. Constraints: min: 0, max: 100 |
No | 100 |
| output_format | enum | The output format of the generated image. One of png, webp, orjpeg. Default: png.Possible values: png, webp, jpeg |
No | png |
| partial_images | integer | Number of partial images to generate in streaming mode, from 0 (default value) to 3. Constraints: min: 0, max: 3 |
No | |
| quality | enum | The quality of the generated image. One of low, medium, high,or auto. Default: auto.Possible values: low, medium, high, auto |
No | auto |
| size | string (see valid models below) | The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792. |
No | |
| type | enum | The type of the image generation tool. Always image_generation.Possible values: image_generation |
Yes | image_generation |
OpenAI.ImageGenToolInputImageMask
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_id | string | No | ||
| image_url | string (uri) | No |
OpenAI.InlineSkillParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | The description of the skill. | Yes | |
| name | string | The name of the skill. | Yes | |
| source | OpenAI.InlineSkillSourceParam | Inline skill payload | Yes | |
| └─ data | string | Base64-encoded skill zip bundle. Constraints: minLength: 1, maxLength: 70254592 |
Yes | |
| └─ media_type | enum | The media type of the inline skill payload. Must be application/zip.Possible values: application/zip |
Yes | application/zip |
| └─ type | enum | The type of the inline skill source. Must be base64.Possible values: base64 |
Yes | base64 |
| type | enum | Defines an inline skill for this request. Possible values: inline |
Yes | inline |
OpenAI.InlineSkillSourceParam
Inline skill payload
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | string | Base64-encoded skill zip bundle. Constraints: minLength: 1, maxLength: 70254592 |
Yes | |
| media_type | enum | The media type of the inline skill payload. Must be application/zip.Possible values: application/zip |
Yes | application/zip |
| type | enum | The type of the inline skill source. Must be base64.Possible values: base64 |
Yes | base64 |
OpenAI.InputAudio
Input audio
An audio input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| input_audio | OpenAI.InputAudioInputAudio | Yes | ||
| type | enum | The type of the input item. Always input_audio.Possible values: input_audio |
Yes |
OpenAI.InputAudioInputAudio
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | string | Yes | ||
| format | enum | Possible values: mp3, wav |
Yes |
OpenAI.InputContent
Discriminator for OpenAI.InputContent
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
input_text |
OpenAI.InputContentInputTextContent |
input_image |
OpenAI.InputContentInputImageContent |
input_file |
OpenAI.InputContentInputFileContent |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.InputContentType | Yes |
OpenAI.InputContentInputFileContent
Input file
A file input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.FileInputDetail | No | ||
| file_data | string | The content of the file to be sent to the model. | No | |
| file_id | string or null | No | ||
| file_url | string (uri) | The URL of the file to be sent to the model. | No | |
| filename | string | The name of the file to be sent to the model. | No | |
| type | enum | The type of the input item. Always input_file.Possible values: input_file |
Yes | input_file |
OpenAI.InputContentInputImageContent
Input image
An image input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.ImageDetail | Yes | ||
| file_id | string or null | No | ||
| image_url | string or null | No | ||
| type | enum | The type of the input item. Always input_image.Possible values: input_image |
Yes | input_image |
OpenAI.InputContentInputTextContent
Input text
A text input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| text | string | The text input to the model. | Yes | |
| type | enum | The type of the input item. Always input_text.Possible values: input_text |
Yes | input_text |
OpenAI.InputContentType
| Property | Value |
|---|---|
| Type | string |
| Values | input_textinput_imageinput_file |
OpenAI.InputFidelity
Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
| Property | Value |
|---|---|
| Type | string |
| Values | highlow |
OpenAI.InputFileContentParam
Input file
A file input to the model.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.FileInputDetail | No | ||
| file_data | string or null | No | ||
| file_id | string or null | No | ||
| file_url | string or null | No | ||
| filename | string or null | No | ||
| type | enum | The type of the input item. Always input_file.Possible values: input_file |
Yes | input_file |
OpenAI.InputImageContentParamAutoParam
Input image
An image input to the model. Learn about image inputs
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| detail | OpenAI.DetailEnum or null | No | ||
| file_id | string or null | No | ||
| image_url | string or null | No | ||
| type | enum | The type of the input item. Always input_image.Possible values: input_image |
Yes | input_image |
OpenAI.InputItem
An item representing part of the context for the response to be generated by the model. Can contain text, images, and audio inputs, as well as previous assistant responses and tool call outputs.
Discriminator for OpenAI.InputItem
This component uses the property type to discriminate between different types:
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.InputItemType | Yes |
OpenAI.InputItemApplyPatchToolCallItemParam
Apply patch tool call
A tool call representing a request to create, delete, or update files using diff patches.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| call_id | string | The unique ID of the apply patch tool call generated by the model. Constraints: minLength: 1, maxLength: 64 |
Yes | |
| id | string or null | No | ||
| operation | OpenAI.ApplyPatchOperationParam | One of the create_file, delete_file, or update_file operations supplied to the apply_patch tool. | Yes | |
| └─ type | OpenAI.ApplyPatchOperationParamType | Yes | ||
| status | OpenAI.ApplyPatchCallStatusParam | Status values reported for apply_patch tool calls. | Yes | |
| type | enum | The type of the item. Always apply_patch_call.Possible values: apply_patch_call |
Yes | apply_patch_call |
OpenAI.InputItemApplyPatchToolCallOutputItemParam
Apply patch tool call output
The streamed output emitted by an apply patch tool call.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| call_id | string | The unique ID of the apply patch tool call generated by the model. Constraints: minLength: 1, maxLength: 64 |
Yes | |
| id | string or null | No | ||
| output | string or null | No | ||
| status | OpenAI.ApplyPatchCallOutputStatusParam | Outcome values reported for apply_patch tool call outputs. | Yes | |
| type | enum | The type of the item. Always apply_patch_call_output.Possible values: apply_patch_call_output |
Yes | apply_patch_call_output |
OpenAI.InputItemCodeInterpreterToolCall
Code interpreter tool call
A tool call to run code.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| code | string or null | Yes | ||
| container_id | string | The ID of the container used to run the code. | Yes | |
[...]
